#include <stdio.h>
#include <fcntl.h>
#include <sys/mnttab.h>
#include <sys/statvfs.h>
#include <sys/vfstab.h>

main(int argc, char *argv[])
{
	void	fatal(char *);
	FILE	*mount_table_fp;
	struct	mnttab mount_table;
	struct	statvfs system_info;
	int	mount_return;
	float	usage;

	if((mount_table_fp = fopen("/etc/mnttab", "r")) == NULL)
		fatal("fopen");
	printf("%-20s %10s %10s %10s %6s %-10s\n", "file system", "total", "used", "avail", "usage", "point");
	while((mount_return = getmntent(mount_table_fp, &mount_table)) == 0)
	{
	if(hasmntopt(&mount_table, "ignore") == 0)
		{
		if(statvfs(mount_table.mnt_mountp, &system_info) < 0)
			fatal("statvfs");
		if(system_info.f_blocks == 0 || system_info.f_bavail == 0)
			usage = 0;
		else	usage = ((float)(system_info.f_blocks - system_info.f_bavail)) 
			/ (float)system_info.f_blocks * 100;

		printf("%-20s %10u %10u %10d %5.0f%% %s\n",
			mount_table.mnt_special, 
			system_info.f_blocks,
			system_info.f_blocks - system_info.f_bavail,
			system_info.f_bavail,
			usage + 0.5,
			mount_table.mnt_mountp);
		}

	}

	switch(mount_return)
		{
		case	-1 :
			break;
		case	MNT_TOOLONG :
			puts("The line is too long");
			break;
		case	MNT_TOOMANY :
			puts("The line has too fields");
			break;
		case	MNT_TOOFEW :
			puts("The line has not enough fields");
			break;
		}
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
