#include <stdio.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <sys/procfs.h>

main()
{
	void	fatal(char *);
	void	read_directory(DIR *);
	DIR	*proc_directory;

	if(!(proc_directory = opendir("/proc")))
		fatal("opendir");

	read_directory(proc_directory);

	closedir(proc_directory);
}

void
read_directory(DIR *dir)
{
	void	fatal(char *);
	void	print_process_information(prpsinfo_t *);
	struct	dirent *directory;
	struct	stat file_stat;
	char	path[20];
	prpsinfo_t	prpsinfo;

	int	fd;

	while(directory = readdir(dir))
		{
		if(*(directory->d_name) == '.')
			continue;
		if(directory->d_ino == 0)
			continue;
		sprintf(path, "%s/%s", "/proc/", directory->d_name);
		if((fd = open(path, O_RDONLY)) < 0)
			continue;
		if(stat(path, &file_stat) < 0)
			continue;

		if(ioctl(fd, PIOCPSINFO, &prpsinfo) < 0)
			fatal("ioctl");

		print_process_information(&prpsinfo);
		}
}

void
print_process_information(prpsinfo_t *p)
{
	printf("μ  ȣ \t%d\n", p->pr_state);
	printf("μ   \t\t%c\n", p->pr_sname);
	printf("CPU 뷮  nice \t%d\n", p->pr_nice);
	printf("μ ÷ \t%ul\n", p->pr_flag);
	printf("μ  ID \t\t%d\n", p->pr_uid);
	printf("μ ׷ ID \t%d\n", p->pr_gid);
	printf("μ θ μ ID \t%d\n", p->pr_ppid);
	printf("μ  + ý CPU  ð \t%d\n", p->pr_time.tv_sec);
}
void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
