#include <stdio.h>
#include <stdlib.h>

#define  FOREVER while(1)
#define  SIZE 7
#define  AVERAGE 49
#define  MAX	 50 


struct	system_information {
	int	year;
	int	month;
	int	day;
	int	hour;
        double  cpu;
        double  user;
        double  kernel;
        double  iowait;
        double  swap;
        double  load_1;
        double  load_5;
        double  load_15; 
        double  memory; 
};

struct	total_system {
	double cpu;
	double user;
	double kernel;
	double iowait;
	double swap;
	double load_1;
	double load_5;
	double load_15;
	double memory;
};

struct	save_system_information {
	char	year   [5];
	char	month  [3];
	char	day    [3];
	char	hour   [3];
	char	minute [3];
	char	cpu    [7];	
	char	user   [7];
	char	kernel [7];
	char	iowait [7];
	char	swap   [7];
	char	load_1 [7];
	char	load_5 [7];
	char	load_15[7];
	char	memory [7];
};

struct total_system *total;

main(int argc, char *argv[])
{
	void	Error(char *);
	void	print_head();
	void	read_one_line(FILE *, char *);
	void	print_menu_item(int *, int *);
	void	display_month(int, struct system_information *);
	void	display_day(int, struct system_information *);
	void	display_hour(int, struct system_information *);
	void	save_system_info(
		struct save_system_information *,
		struct system_information *,
		char *);

	int	result;
	FILE	*log_file;
	char	*line;
	int	main_menu, sub_menu;
	struct	system_information *sys;
	struct	save_system_information *save;


	total = (struct total_system *)malloc(sizeof(struct total_system));
	save  = (struct save_system_information *)
		malloc(sizeof(struct save_system_information));
	sys   = (struct system_information *)
		malloc(sizeof(struct system_information));

	FOREVER	{

	if((log_file = fopen("log_file2", "r")) == NULL)
		Error("fopen");

	print_menu_item(&main_menu, &sub_menu);
	print_head();
	read_one_line(log_file, line);
	while(line[0])
		{
		read_one_line(log_file, line);
		save_system_info(save, sys, line);

		if(line[0] == '\0')
			{
			sys->month += 1;
			sys->day   += 1;
			sys->hour  += 1;
			}
		
		switch(sub_menu)
			{
			case	'1'	:
				display_month(main_menu, sys);
				break;
			case	'2'	:
				display_day(main_menu, sys);
				break;
			case	'3'	:
				display_hour(main_menu, sys);
				break;
			}

		}

	fclose(log_file);
	}

}

void
save_system_info(struct save_system_information *save,
	struct system_information *sys,
	char *line)
{
	sscanf(line, "%s %s %s %s %s"
		"%s %s %s"
		"%s %s %s %s %s"
		"%s",
		save->year, save->month, save->day, save->hour, save->minute,
		save->load_1, save->load_5, save->load_15,
		save->cpu, save->user, save->kernel, save->iowait, save->swap,
		save->memory);

	sys->year    = (int)atof(save->year);
	sys->month   = (int)atof(save->month);
	sys->day     = (int)atof(save->day);
	sys->hour    = (int)atof(save->hour);
	sys->load_1  = atof(save->load_1);
	sys->load_5  = atof(save->load_5);
	sys->load_15 = atof(save->load_15);
	sys->cpu     = atof(save->cpu);
	sys->user    = atof(save->user);
	sys->kernel  = atof(save->kernel);
	sys->iowait  = atof(save->iowait);
	sys->swap    = atof(save->swap);
	sys->memory  = atof(save->memory);
}

void
read_one_line(FILE *log_file, char read_line[])
{
	int	i;
	int	character = 0;	

	character = fgetc(log_file);
	while(character != '\n' && character >  0)
	for(i = 0;(character != '\n' && character > 0);i++)
		{
		read_line[i] = character;
		character = 0;
		character = fgetc(log_file);
		}

	read_line[i] = '\0';
	if(character <= 0) read_line[0] = '\0';
}

void
print_menu_item(int *main_menu, int *sub_menu)
{
	do	{
		puts("");
		puts("===========");
		puts("1. average");
		puts("2. max");
		puts("");
		puts("0. exit");
		puts("===========");
		*main_menu = getchar();
		if(*main_menu != '\n');
		else	*main_menu = '3';
	} while(*main_menu > '2');

	if(*main_menu == '0')
		exit(0);

	puts("1. month");
	puts("2. day");
	puts("3. hour");
	*sub_menu = getchar();
	getchar();
}

void
display_month(int main_menu, struct system_information *sys)
{
	void	initialize();
	void	add_total(struct system_information *);
	void	calculate_average(struct total_system *, int);
	void	print_average(struct total_system *, int, int, int);
	void	print_max(struct total_system *, int, int, int);
	void	calculate_max(struct total_system *, struct system_information *);

	static	int month;
	static	int day;
	static	int hour;
	static	int count;
	static	struct	total_system *max;
	struct	total_system *average;



	if(count == 0)
		month = sys->month;

	
	if(main_menu == AVERAGE)
	{
		if(month != sys->month)
			{
			average = (struct total_system *)
				malloc(sizeof(struct total_system));
			calculate_average(average, count + 1);
			print_average(average, month, 0, 0);
			initialize();
			add_total(sys);

			free(average);
			count = 0;
			return;
			}
		add_total(sys);
	} else	{
		if(count == 0)
			{
			max = (struct total_system *)
				malloc(sizeof(struct total_system));
			initialize(max);
			}
		calculate_max(max, sys);
		if(month != sys->month)
			{
			print_max(max, month, 0, 0);
			free(max);
			count = 0;
			return;
			}
		}

	count++;
		
}

void
print_max(struct total_system *max, int month, int day, int hour)
{
	if(hour > 0)
		printf(" %2d %2d %2d :%5.1f", month, day, hour, max->cpu);
	else	if(day > 0)
		printf("  %3d %3d :%5.1f", month, day, max->cpu);
	else	if(month > 0)
		printf("   %6d :%5.1f", month, max->cpu);

	printf("%7.1f",   max->user);
	printf("%7.1f",   max->kernel);
	printf("%7.1f",   max->iowait);
	printf("%7.1f",   max->swap);
	printf("%7.1f",   max->load_1);
	printf("%7.1f",   max->load_5);
	printf("%8.1f",   max->load_15);
	printf("%7.1f\n", max->memory);
}

void
calculate_max(struct total_system *max, struct system_information *sys)
{
	if(max->cpu     < sys->cpu)     max->cpu     = sys->cpu;
	if(max->user    < sys->user)    max->user    = sys->user;
	if(max->kernel  < sys->kernel)  max->kernel  = sys->kernel;
	if(max->iowait  < sys->iowait)  max->iowait  = sys->iowait;
	if(max->swap    < sys->swap)    max->swap    = sys->swap;
	if(max->load_1  < sys->load_1)  max->load_1  = sys->load_1;
	if(max->load_5  < sys->load_5)  max->load_5  = sys->load_5;
	if(max->load_15 < sys->load_15) max->load_15 = sys->load_15;
	if(max->memory  < sys->memory)  max->memory  = sys->memory;
}

void
initialize(struct total_system *max)
{
	total->cpu     = 0.;
	total->user    = 0.;
	total->kernel  = 0.;
	total->iowait  = 0.;
	total->swap    = 0.;
	total->load_1  = 0.;
	total->load_5  = 0.;
	total->load_15 = 0.;
	total->memory  = 0.;

	max->cpu       = 0.;
	max->user      = 0.;
	max->kernel    = 0.;
	max->iowait    = 0.;
	max->swap      = 0.;
	max->load_1    = 0.;
	max->load_5    = 0.;
	max->load_15   = 0.;
	max->memory    = 0.;
	
}

void
print_average(struct total_system *average, int month, int day, int hour)
{
	if(hour > 0)
		printf(" %2d %2d %2d :%5.1f", month, day, hour, average->cpu);
	else	if(day > 0)
		printf("  %3d %3d :%5.1f", month, day, average->cpu);
	else	if(month > 0)
		printf(" %8d :%5.1f", month, average->cpu);

	printf("%7.1f",   average->user);
	printf("%7.1f",   average->kernel);
	printf("%7.1f",   average->iowait);
	printf("%7.1f",   average->swap);
	printf("%7.1f",   average->load_1);
	printf("%7.1f",   average->load_5);
	printf("%8.1f",   average->load_15);
	printf("%7.1f\n", average->memory);
}

void
calculate_average(struct total_system *average, int count)
{
	average->cpu     = total->cpu     / count;
	average->user    = total->user    / count;
	average->kernel  = total->kernel  / count;
	average->iowait  = total->iowait  / count;
	average->swap    = total->swap    / count;
	average->load_1  = total->load_1  / count;
	average->load_5  = total->load_5  / count;
	average->load_15 = total->load_15 / count;
	average->memory  = total->memory  / count;

}

void
add_total(struct system_information *sys)
{
	total->cpu     += sys->cpu;
	total->user    += sys->user;
	total->kernel  += sys->kernel;
	total->iowait  += sys->iowait;
	total->swap    += sys->swap;
	total->load_1  += sys->load_1;
	total->load_5  += sys->load_5;
	total->load_15 += sys->load_15;
	total->memory  += sys->memory;
}

void
display_day(int main_menu, struct system_information *sys)
{
        void    initialize();
        void    add_total(struct system_information *);
        void    calculate_average(struct total_system *, int);
        void    print_average(struct total_system *, int, int, int);
        void    print_max(struct total_system *, int, int, int);
        void    calculate_max(struct total_system *, struct system_information *);

	static	int month;
	static	int day;
	static	int count;
        static  struct  total_system *max;
        struct  total_system *average;


	if(count == 0)
		{
		month = sys->month;
		day   = sys->day;
		}

	
	if(main_menu == AVERAGE)
	{
		if(day != sys->day)
			{
			average = (struct total_system *)
				malloc(sizeof(struct total_system));
			calculate_average(average, count + 1);
			print_average(average, month, day, 0);
			initialize();
			add_total(sys);

			free(average);
			count = 0;
			return;
			}

		add_total(sys);

	} else	{
		if(count == 0)
			{
			max = (struct total_system *)
				malloc(sizeof(struct total_system));
			initialize();
			}

		calculate_max(max, sys);
		if(day != sys->day)
			{
			print_max(max, month, day, 0);
			free(max);
			count = 0;
			return;
			}
		}

	count++;
}

void
display_hour(int main_menu, struct system_information *sys)
{
        void    initialize();
        void    add_total(struct system_information *);
        void    calculate_average(struct total_system *, int);
        void    print_average(struct total_system *, int, int, int);
        void    print_max(struct total_system *, int, int, int);
        void    calculate_max(struct total_system *, struct system_information *);

	static	int month;
	static	int day;
	static	int hour;
	static	int count;
        static  struct  total_system *max;
        struct  total_system *average;

	if(count == 0)
		{
		month = sys->month;
		day   = sys->day;
		hour  = sys->hour;
		}
	
	if(main_menu == AVERAGE)
	{
		if(hour != sys->hour)
			{
			average = (struct total_system *)
				malloc(sizeof(struct total_system));
			calculate_average(average, count + 1);
			if(hour == 0) hour = 24;
			print_average(average, month, day, hour);
			initialize();
			add_total(sys);

			free(average);
			count = 0;
			return;
			}

		add_total(sys);

	} else	{
		if(count == 0)
			{
			max = (struct total_system *)
				malloc(sizeof(struct total_system));
			initialize();
			}

		calculate_max(max, sys);

		if(hour != sys->hour)
			{
			if(hour == 0) hour = 24;
			print_max(max, month, day, hour);
			free(max);
			count = 0;
			return;
			}
		}

	count++;
}

void
print_head()
{
	printf("%9s%7s%7s%7s%7s%7s%7s%7s%8s%7s\n",
		"    date", "cpu", "user", "kernel", "iowait", "swap",
		"load 1", "load 5", "load 15", "memory");
	puts("  -----------------------------------"
		"--------------------------------------");
}

void
Error(char *error_name)
{
	perror(error_name);
	exit(0);
}
