#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/signal.h>
#include <procfs.h>
#include <sys/param.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <time.h>
#include <dirent.h>
#include <sys/socket.h>

#define NUM_AVERAGES    3
#define  FOREVER while(1)

struct system_info{
	double load_avg[NUM_AVERAGES];
	int    *cpustates;
	int    *memory_state;
};

int main()
{
	void	save_log   ();
	void	send_client();
	int	id;
	struct	system_info system_information;


	if((id = fork()) < 0)
		{
		puts("fork error");
		exit(0);
		}
	
	if(id == 0)	/* child */
		save_log();
	else		/* parent */	
		send_client();
	
		

}

void
save_log()
{
	char	*add_information(struct system_info *);

	struct	system_info system_information;
	FILE	*log_file;
	char	*total_log;
        static	int count = 0;
	time_t	current_time;
	struct	tm *t;
	int	current;


	time(&current_time);
	t = localtime(&current_time);
	current = t->tm_min;
	

	FOREVER
	{

	time(&current_time);
	t = localtime(&current_time);



	if(t->tm_min == current)
		{
		sleep(60);
		continue;
		}
	else	{

		if((log_file = fopen("log_file", "a")) == NULL)
			{
			perror("fopen");
			exit(0);
			}

		current = t->tm_min;
		get_system_information(&system_information);
		}

	total_log = add_information(&system_information);

	if(count == 0) { count = 1; sleep(1); continue; }

	
	fprintf(log_file, "%s\n", total_log);
	fclose(log_file);

	}

}

void
send_client()
{
	char	*add_information(struct system_info *);

	char	*total_log;
	char	send_log[100];
        void    Fatal(char *);
        int     server_fd, client_fd;
        int     port = 4999;
        int     client_length;
        struct  sockaddr_in server_address, client_address;
	struct	system_info system_information;


	if((server_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		Fatal("socket");
        bzero((char *)&server_address, sizeof(server_address));
        server_address.sin_family = AF_INET;
        server_address.sin_addr.s_addr = htonl(INADDR_ANY);
        server_address.sin_port = htons(port);

	if(bind(server_fd, (struct sockaddr *)&server_address, sizeof(server_address)) < 0)
		Fatal("bind");
	listen(server_fd, 1);
	puts("server ready");

        client_length = sizeof(client_address);

        if((client_fd = accept(server_fd,
                (struct sockaddr *)&client_address, &client_length)) < 0)
                Fatal("accept");
        puts("client connected");

	FOREVER
	{
	get_system_information(&system_information);
	total_log = add_information(&system_information);
	strcpy(send_log, total_log);
	write(client_fd, send_log, strlen(send_log));
	sleep(5);
	}

}

char *
add_information(struct system_info *s)
{
	extern	int format_k(int);

	int	i, j;
        int	value;
	int	*states = s->cpustates;
        char    *cpu_state_menu[] = 
                {"idle", "user", "kernel", "iowait", "swap", NULL};
        char	**names = cpu_state_menu;
        char	*thisname;
	time_t	current_time;
	struct	tm *t;
	static	char total_log[70];
	char	log_string[20];
	char	*imsi;
	int	total_memory, free_memory;



	time(&current_time);
	t = localtime(&current_time);

	sprintf(log_string, "%4d %2d %2d %2d %2d ",
		t->tm_year+1900,
		t->tm_mon+1,
		t->tm_mday,
		t->tm_hour,
		t->tm_min);
	strcpy(total_log, "");
	strcpy(total_log, log_string);


        /* **************************************************** */
        // load average
        /* **************************************************** */
        for (i = 0; i < 3; i++)
		{
		sprintf(log_string, "%5.2f", s->load_avg[i]);
		strcat(total_log, log_string);
		}

        /* **************************************************** */
        // cpu state
        /* **************************************************** */

	strcat(total_log, " ");

        for(j = 0;j < 5;j++)
                {
                thisname = *names++;
                if (*thisname != '\0')
                        {
                        value = *states++;
			if(j == 0)
				{
				sprintf(log_string, "%5.1f", 100. - (float)value / 10.);
				strcat(total_log, log_string);
				continue;
				}
			sprintf(log_string, "%5.1f", (float)value / 10.);
			strcat(total_log, log_string);
                        }
                }

        /* **************************************************** */
        // memory state
        /* **************************************************** */
	total_memory = format_k(*(s->memory_state));
        sprintf(log_string, " %d ", format_k(*(s->memory_state++)));
	*(s->memory_state++);
	free_memory = format_k(*(s->memory_state));
	sprintf(log_string, " %d\n", format_k(*(s->memory_state)));
	sprintf(log_string, "%6.1f", 100. - (((float)free_memory/total_memory) * 100.));
	strcat(total_log, log_string);


	return (total_log);


}

void
Fatal(char *error_name)
{
        perror(error_name);
        exit(0);
}

